#include <iostream>
#include <ctime>
#include <cstdlib>
#include <math.h>
//#include "datastructure.h"
#include "sector.h"

//#include <algorithm>

using namespace std;


class Util{
  public:
    static int vGenerator(int centerNum, int offset){
        return (rand()%(offset*2+1))-offset+centerNum;        
    }

    static int vGenerator1(int begin, int end){
        return (rand()%(end-begin))+begin;        
    }

    static int aGenerator(int begin, int end){
        int ang=(rand()%(end-begin))+begin;
        if(ang%90==0)
         ang+=1;
        return ang;
    }

    static int pGenerator(int d = 200){
      int p=d-1;
      return ( rand()%p + 1); //between 1 to 199
    }

    static int pGenerator1(int s = 0, int d = 200){
      int p=d - s -1;
      return ( rand()%p + 1 + s); //between 1 to 199
    }

};


int Billiard::ballCounter = 0;

int main()
{
  srand((unsigned)time(0));
  Sector s = Sector(Coordinate(50,50), Coordinate(100,100));
  bool br=false;
  for( int i = 0; i < 50; i++){
    Velocity v = Velocity(Util::vGenerator1(2, 6), Util::aGenerator(1, 360));
    Coordinate c = Coordinate(Util::pGenerator1(50, 100), Util::pGenerator1(50,100));
    Billiard* pb = new Billiard(c, v);
    br=s.addABilliard(pb);   
    if(!br){
      i--;
      delete pb;
    }    
  }
  //s.print();
  s.run(1000.0);
  //s.print();
  //s.collisionTest();
  //Event* collEvent = s.getNextCollisionEvent();
//  Event* bounEvent = s.getNextBounceEvent();
  //collEvent->print();
//  bounEvent->print();
  //delete collEvent;
//  delete bounEvent;
} 

